/*
TrayButtonTest.cpp					Copyright  2004 by George A. Nelson

By:  Tony Nelson  on   1 Feb 05	

Description:  Demo TrayButton.cp

*/

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#define UNICODE -- done in project settings

#include "CmnHdr.h"				// Richter _Programming Applications..._
#include <WindowsX.h>
#include <stdlib.h>
#include <tchar.h>

#include "resource.h"
#include "TrayButton.h"


/*	Globals
*/
static HINSTANCE	hInst;
static HWND			gMainHwnd;
static DWORD		gTrayMinimize = 0;


/*	Message handlers for our main window.
*/
	static BOOL
Dlg_OnInitDialog( HWND hwnd, HWND hwndFocus, LPARAM lParam )
{
	//chSETDLGICONS( hwnd, IDI_APPICON );
	SendMessage(hwnd, WM_SETICON, ICON_BIG,  (LPARAM) 
		LoadIcon(hInst, MAKEINTRESOURCE(IDI_APPICON)));
	SendMessage(hwnd, WM_SETICON, ICON_SMALL, (LPARAM) 
		(HICON) LoadImage( hInst, MAKEINTRESOURCE(IDI_APPICON), IMAGE_ICON,
		GetSystemMetrics(SM_CXSMICON), GetSystemMetrics(SM_CYSMICON), 0));

	CheckDlgButton( hwnd, IDC_TRAYMINIMIZE, gTrayMinimize );
	return true;
}


	static void
Dlg_OnCommand( HWND hwnd, int id, HWND hwndCtl, UINT codeNotify )
{
	switch( id ) {
	case IDOK:
	case IDCANCEL:
		DestroyWindow( hwnd );
		break;

	case IDC_TRAYMINIMIZE:
		gTrayMinimize = IsDlgButtonChecked( hwnd, IDC_TRAYMINIMIZE ) == BST_CHECKED;
		SetTrayButton( hwnd, gTrayMinimize );
		break;
	}
}


	static void
Dlg_OnDestroy( HWND hwnd )
{
	gMainHwnd = NULL;
	PostQuitMessage( 0 );
}


	static INT_PTR WINAPI
Dlg_Proc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg ) {
		chHANDLE_DLGMSG( hwnd, WM_INITDIALOG,    Dlg_OnInitDialog );
		chHANDLE_DLGMSG( hwnd, WM_COMMAND,       Dlg_OnCommand );
		chHANDLE_DLGMSG( hwnd, WM_DESTROY,       Dlg_OnDestroy );
	}

	return FALSE;
}


	int APIENTRY
_tWinMain( HINSTANCE hInstExe, HINSTANCE, LPSTR pszCmdLine, int iCmdShow )	//_txxx from <tchar.h>
{
	hInst = hInstExe;

	gMainHwnd = CreateDialog( hInst, MAKEINTRESOURCE(IDD_MAIN), NULL, Dlg_Proc );
	if( !gMainHwnd )		// tampering?
		return 1;

	InitTrayButton( gMainHwnd, &iCmdShow, gTrayMinimize );
	
	ShowWindow( gMainHwnd, iCmdShow );
	
	MSG msg;
	BOOL msgErr;
	while( (msgErr = GetMessage(&msg, NULL, 0, 0)) != 0
	    && msgErr != -1 )
	{
		if( !gMainHwnd || !IsDialogMessage(gMainHwnd, &msg) ) { 
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
	}

	return msg.wParam;
}
